{% extends "baseAjaxTable.html" %}
{% block content %}
{% if current_user.is_authenticated %}
  {% if current_user.est_moniteur() %}
  <button  data-toggle="modal" class="btn btn-danger btn-del" data-target="#modalSupprimer">Supprimer la ligne</button>
  <button type="button" class="btn btn-secondary btn-add" data-toggle="modal" data-target="#ModalPaiementForm"> Ajouter un Paiement</button>
  <button type="button" class="btn btn-secondary btn-edit" data-toggle="modal" data-target="#ModalModifPaiementForm"> Modifier le Paiement</button>
  {% elif not current_user.is_cotisation() %}
  
  <!--Ajouter conditions à déja cotisation-->
  <button type="button"  data-target="#ModalPaiementForm" class="btn btn-secondary btn-add" data-toggle="modal" >Cotiser</button>
  {% endif %}
  <button type="button" id="btn-filtre" class="btn btn-secondary" data-toggle="modal" data-target="#ModalPaiementFormFiltre"> Filtrer</button>
{% endif %}

  <table id="data" class="table table-striped display table-bordered">
    <thead>
      <tr>
        <th>ID Paiement</th>
        <th>IDClient</th>
        <th>Prenom Nom client</th>
        <th>Date</th>
        <th>Prix</th>
      </tr>
    </thead>
    <tbody>

    </tbody>
  </table>
  <!--Modal s'affichant lors du clique de supprimer pour savoir si on veut vraiment supprimer-->
  <div class="modal fade" id="modalSupprimer" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Supprimer</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <p>Etes-vous sur de vouloir supprimer ce Paiement ?</p>
          <span id="Paiementsup"></span>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Fermer</button>
          <button type="button" class="btn btn-danger" id="deletePaiement" data-dismiss="modal">Supprimer</button>
          
        </div>
      </div>
    </div>
</div>


<div id="ModalPaiementForm" class="modal fade modal-Paiement" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Ajouter un Paiement</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST", action="{{url_for('save_paiement')}}">
                {{ form.hidden_tag() }}
                {% if current_user.est_moniteur() %}
                  {% for field in form.get_form_field() %}
                      {% if form[field].type == 'SelectField' %}
                          <div class="form-group{% if form[field].errors %} has-error{% endif %} selectFieldClasse2" style="width: 75%">
                              {{ form[field].label }} {{ form[field](size=1) }}
                          </div>
                      {% elif form[field].type == 'BooleanField' %}
                          <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                              {{ form[field].label }} {{ form[field](size=1) }}
                          </div>
                      {% else %}
                          <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                              {{ form[field].label }} {{ form[field](size=50, class_="form-control") }}
                          </div>
                      {% endif %}
                      {% if form[field].errors %}
                          <ul class="list-group">
                              {% for e in form[field].errors %}
                              <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                              {% endfor %}
                          </ul >
                      {% endif %}
                  {% endfor %}
                {% else %}
                {% for field in form.get_form_field_client() %}
                      {% if form[field].type == 'SelectField' %}
                          <div class="form-group{% if form[field].errors %} has-error{% endif %} selectFieldClasse2" style="width: 75%">
                              {{ form[field].label }} {{ form[field](size=1) }}
                          </div>
                      {% elif form[field].type == 'BooleanField' %}
                          <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                              {{ form[field].label }} {{ form[field](size=1) }}
                          </div>
                      {% else %}
                          <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                              {{ form[field].label }} {{ form[field](size=50, class_="form-control") }}
                          </div>
                      {% endif %}
                      {% if form[field].errors %}
                          <ul class="list-group">
                              {% for e in form[field].errors %}
                              <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                              {% endfor %}
                          </ul >
                      {% endif %}
                  {% endfor %}
                {% endif %}
                <input type="submit" class="btn btn-primary" value="Ajouter">
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->

<div id="ModalModifPaiementForm" class="modal fade modal-Paiement" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Modifier le Paiement</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST", action="{{url_for('edit_paiement')}}">
                {{ form.hidden_tag() }}
                {% for field in form.get_form_field() %}
                    {% if form[field].type == 'SelectField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} selectFieldClasse2" style="width: 75%">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% elif form[field].type == 'BooleanField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% else %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                            {{ form[field].label }} {{ form[field](size=50, class_="form-control") }}
                        </div>
                    {% endif %}
                    {% if form[field].errors %}
                        <ul class="list-group">
                            {% for e in form[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <input type="submit" class="btn btn-primary" value="Modifier">
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->


<div id="ModalPaiementFormFiltre" class="modal fade modal-paiement" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Filtrer</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST">
                {{ form.hidden_tag() }}
                {% for field in form_filtre.get_form_field() %}
                    {% if form_filtre[field].type == 'SelectField' %}
                      <div class="form-group{% if form_filtre[field].errors %} has-error{% endif %}">
                        {{ form_filtre[field].label }} {{ form_filtre[field](size=1) }}
                      </div>
                    {% else %}
                      <div class="form-group{% if form_filtre[field].errors %} has-error{% endif %}">
                            {{ form_filtre[field].label }} {{ form_filtre[field](size=50, class_="form-control") }}
                        </div>
                    {% endif %}
                    {% if form_filtre[field].errors %}
                        <ul class="list-group">
                            {% for e in form_filtre[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <button type="button" id="btn-filtre-save" class="btn btn-secondary" data-toggle="modal" data-target="#ModalPaiementFormFiltre"> Filtrer</button>
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->
{% endblock %}

{% block scripts %}
  <script>
    let row = null;

    $(document).ready(function(){
      let open_modal = '{{open_modal}}';
      if (open_modal) {
        $('#ModalPaiementForm').modal('show');
      }
      let open_modal_edit = '{{open_modal_edit}}';
      if (open_modal_edit) {
        $('#ModalModifPaiementForm').modal('show');
      }
      
      $(".btn-edit").prop("disabled",true);
      $(".btn-del").prop("disabled",true);
      let table = $('#data').DataTable({
        ajax:{
              url:'/api/data/paiement',
                type:"POST",
                data:function(Paiement1){
                    if(Paiement1!=undefined){
                      Paiement1.nom_prenom_client_filtre = $("#nom_prenom_client_filtre").val();
                      Paiement1.date_reservation_filtre = $("#date_reservation_filtre").val();
                      Paiement1.prix_filtre = $("#prix_filtre").val();
                  }
                  return Paiement1
                }
        },
        columns: [
          {data: 'idh'},
          {data: 'idcl'},
          {data: 'prenom_nom_client', searchable: true, orderable:true},
          {data: 'date', searchable: true, orderable:true},
          {data: 'prix', searchable: false, orderable:true},
        ],
      
        
      });

       $("#data").on("click", "tr", function() {
            if(row !=null){
                $(row).css('background-color', "");     
            }
            $(".btn-edit").prop("disabled",false);
            $(".btn-del").prop("disabled",false);
            row = this;
            $(this).css('background-color', "#AFE1AF");
            $("#Paiementsupprimer").html($(row)[0].childNodes[1].innerHTML+ " " + $(row)[0].childNodes[2].innerHTML)
        });

        $("#deletePaiement").on("click",function(){
            $.ajax({
                url:'{{url_for("delete_paiement")}}',
                type:'POST',
                data:{id:$(row)[0].childNodes[0].innerHTML},
            success: function(){
                table.ajax.reload();
                } 
            });       
        });

        $("#data").on("dblclick", "tr", function() {
          row = this;
          let idPaiement = row.childNodes[0].innerHTML;
          window.location.href = "{{ url_for('detail_paiement', id='idPaiement') }}".replace("idPaiement",idPaiement) ;
        });

        $(document).on('click', '.btn-edit', function() {
          // Récupérer les informations de la réservation avec l'id spécifié
          // Préremplir les champs de formulaire dans le modal avec les informations de la réservation
          $('#ModalModifPaiementForm #idh').val($(row)[0].childNodes[0].innerHTML);
          $('#ModalModifPaiementForm #nom_prenom_client').val($(row)[0].childNodes[1].innerHTML);
          $('#ModalModifPaiementForm #date_reservation').val($(row)[0].childNodes[2].innerHTML);
          $('#ModalModifPaiementForm #prix').val($(row)[0].childNodes[3].innerHTML);
          // Afficher le modal
          $('#ModalModifPaiementForm').modal('show');
        });

        $(document).on('click', '.btn-add', function() {
          // Récupérer les informations de la réservation avec l'id spécifié
          // Préremplir les champs de formulaire dans le modal avec les informations de la réservation
          $('#ModalPaiementForm #idh').val("");
          $('#ModalPaiementForm #nom_prenom_client').val("");
          $('#ModalPaiementForm #date_reservation').val("");
          $('#ModalPaiementForm #prix').val("");
          // Afficher le modal
          $('#ModalPaiementForm').modal('show');

          let errorElements = document.getElementsByClassName("list-group-item-danger");

          // Loop through the elements and remove the li element
          while(errorElements.length > 0){
            errorElements[0].parentNode.removeChild(errorElements[0]);
          }
          
        });
     
        $("#btn-filtre-save").on("click",function(){
          table.ajax.reload();
          $("#ModalPaiementFormFiltre").modal("hide");
        });
        $("#btn-filtre").on("click",function(){
            $("#ModalPaiementFormFiltre").modal("show");
        });



    });



    
   
 



    
  </script>
{% endblock %}
<!--
  https://datatables.net/examples/api/select_single_row.html
  https://blog.miguelgrinberg.com/post/beautiful-interactive-tables-for-your-flask-templates-->